Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/cf.data.pre	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/cf.data.pre	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -2812,4 +3063,119 @@
 	and coredump files will be left there.
 DOC_END
 
+NAME: redirector_bypass
+TYPE: onoff
+LOC: Config.onoff.redirector_bypass
+DEFAULT: off
+DOC_START
+	When this is 'on', a request will not go through the
+	redirector if all redirectors are busy.  If this is 'off'
+	and the redirector queue grows too large, Squid will exit
+	with a FATAL error and ask you to increase the number of
+	redirectors.  You should only enable this if the redirectors
+	are not critical to your caching system.  If you use
+	redirectors for access control, and you enable this option,
+	then users may have access to pages that they should not
+	be allowed to request.
+DOC_END
+
+NAME: ignore_unknown_nameservers
+TYPE: onoff
+LOC: Config.onoff.ignore_unknown_nameservers
+DEFAULT: on
+DOC_START
+	By default Squid checks that DNS responses are received
+	from the same IP addresses that they are sent to.  If they
+	don't match, Squid ignores the response and writes a warning
+	message to cache.log.  You can allow responses from unknown
+	nameservers by setting this option to 'off'.
+ignore_unknown_nameservers on
+DOC_END
+
+NAME: digest_generation
+IFDEF: USE_CACHE_DIGESTS
+TYPE: onoff
+LOC: Config.onoff.digest_generation
+DEFAULT: on
+DOC_START
+	This controls whether the server will generate a Cache Digest
+	of its contents.  By default, Cache Digest generation is
+	enabled if Squid is compiled with USE_CACHE_DIGESTS defined.
+digest_generation on
+DOC_END
+
+NAME: digest_bits_per_entry
+IFDEF: USE_CACHE_DIGESTS
+TYPE: int
+LOC: Config.digest.bits_per_entry
+DEFAULT: 5
+DOC_START
+	This is the number of bits of the server's Cache Digest which
+	will be associated with the Digest entry for a given HTTP
+	Method and URL (public key) combination.  The default is 5.
+digest_bits_per_entry 5
+DOC_END
+
+NAME: digest_rebuild_period
+IFDEF: USE_CACHE_DIGESTS
+COMMENT: (seconds)
+TYPE: time_t
+LOC: Config.digest.rebuild_period
+DEFAULT: 1 hour
+DOC_START
+	This is the number of seconds between Cache Digest rebuilds.
+	By default the server's Digest is rebuilt every hour.
+digest_rebuild_period 1 hour
+DOC_END
+
+NAME: digest_rewrite_period
+COMMENT: (seconds)
+IFDEF: USE_CACHE_DIGESTS
+TYPE: time_t
+LOC: Config.digest.rewrite_period
+DEFAULT: 1 hour
+DOC_START
+	This is the number of seconds between Cache Digest writes to
+	disk.  By default the server's Digest is written to disk every
+	hour.
+digest_rewrite_period 1 hour
+DOC_END
+
+NAME: digest_swapout_chunk_size
+COMMENT: (bytes)
+TYPE: b_size_t
+IFDEF: USE_CACHE_DIGESTS
+LOC: Config.digest.swapout_chunk_size
+DEFAULT: 4096 bytes
+DOC_START
+	This is the number of bytes of the Cache Digest to write to
+	disk at a time.  It defaults to 4096 bytes (4KB), the Squid
+	default swap page.
+digest_swapout_chunk_size 4096 bytes
+DOC_END
+
+NAME: digest_rebuild_chunk_percentage
+COMMENT: (percent, 0-100)
+IFDEF: USE_CACHE_DIGESTS
+TYPE: int
+LOC: Config.digest.rebuild_chunk_percentage
+DEFAULT: 10
+DOC_START
+	This is the percentage of the Cache Digest to be scanned at a
+	time.  By default it is set to 10% of the Cache Digest.
+digest_rebuild_chunk_percentage 10
+DOC_END
+
+NAME: chroot
+TYPE: string
+LOC: Config.chroot_dir
+DEFAULT: none
+DOC_START
+	Use this to have Squid do a chroot() while initializing.  This
+	also causes Squid to fully drop root privileges after
+	initializing.  This means, for example, that if you use a HTTP
+	port less than 1024 and try to reconfigure, you will get an
+	error.
+DOC_END
 EOF
+
Index: squid/src/cf_gen.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf_gen.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/cf_gen.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/cf_gen.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,5 +1,5 @@
 /*
- * $Id: cf_gen.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: cf_gen.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: none
  * AUTHOR: Max Okumoto
Index: squid/src/client.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/client.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/client.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/client.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: client.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 0     WWW Client
  * AUTHOR: Harvest Derived
@@ -40,6 +40,7 @@
 #endif
 
 /* Local functions */
+static int client_comm_bind(int, char *);
 static int client_comm_connect(int, char *, u_short, struct timeval *);
 static void usage(const char *progname);
 static int Now(struct timeval *);
@@ -55,7 +56,7 @@
 usage(const char *progname)
 {
     fprintf(stderr,
-	"Usage: %s [-arsv] [-i IMS] [-h host] [-p port] [-m method] [-t count] [-I ping-interval] [-H 'strings'] url\n"
+	"Usage: %s [-arsv] [-i IMS] [-h remote host] [-l local host] [-p port] [-m method] [-t count] [-I ping-interval] [-H 'strings'] url\n"
 	"Options:\n"
 	"    -P file      PUT request.\n"
 	"    -a           Do NOT include Accept: header.\n"
@@ -64,6 +65,7 @@
 	"    -v           Verbose. Print outgoing message to stderr.\n"
 	"    -i IMS       If-Modified-Since time (in Epoch seconds).\n"
 	"    -h host      Retrieve URL from cache on hostname.  Default is localhost.\n"
+	"    -l host      Specify a local IP address to bind to.  Default is none.\n"
 	"    -p port      Port number of cache.  Default is %d.\n"
 	"    -m method    Request method, default is GET.\n"
 	"    -t count     Trace count cache-hops\n"
@@ -85,7 +87,8 @@
     int opt_noaccept = 0;
     int opt_put = 0;
     int opt_verbose = 0;
-    char url[BUFSIZ], msg[BUFSIZ], buf[BUFSIZ], hostname[BUFSIZ];
+    char *hostname, *localhost;
+    char url[BUFSIZ], msg[BUFSIZ], buf[BUFSIZ];
     char extra_hdrs[BUFSIZ];
     const char *method = "GET";
     extern char *optarg;
@@ -97,7 +100,8 @@
     long ping_min = 0, ping_max = 0, ping_sum = 0, ping_mean = 0;
 
     /* set the defaults */
-    strcpy(hostname, "localhost");
+    hostname = "localhost";
+    localhost = NULL;
     extra_hdrs[0] = '\0';
     port = CACHE_HTTP_PORT;
     to_stdout = 1;
@@ -112,14 +116,18 @@
 	strcpy(url, argv[argc - 1]);
 	if (url[0] == '-')
 	    usage(argv[0]);
-	while ((c = getopt(argc, argv, "ah:P:i:km:p:rsvt:g:p:I:H:?")) != -1)
+	while ((c = getopt(argc, argv, "ah:l:P:i:km:p:rsvt:g:p:I:H:?")) != -1)
 	    switch (c) {
 	    case 'a':
 		opt_noaccept = 1;
 		break;
-	    case 'h':		/* host:arg */
+	    case 'h':		/* remote host */
 		if (optarg != NULL)
-		    strcpy(hostname, optarg);
+		    hostname = optarg;
+		break;
+	    case 'l':		/* local host */
+		if (optarg != NULL)
+		    localhost = optarg;
 		break;
 	    case 's':		/* silent */
 		to_stdout = 0;
@@ -250,6 +258,10 @@
 	    perror("client: socket");
 	    exit(1);
 	}
+	if (localhost && client_comm_bind(conn, localhost) < 0) {
+	    perror("client: bind");
+	    exit(1);
+	}
 	if (client_comm_connect(conn, hostname, port, ping ? &tv1 : NULL) < 0) {
 	    if (errno == 0) {
 		fprintf(stderr, "client: ERROR: Cannot connect to %s:%d: Host unknown.\n", hostname, port);
@@ -336,6 +348,25 @@
 }
 
 static int
+client_comm_bind(int sock, char *local_host)
+{
+    static const struct hostent *hp = NULL;
+    static struct sockaddr_in from_addr;
+
+    /* Set up the source socket address from which to send. */
+    if (hp == NULL) {
+	from_addr.sin_family = AF_INET;
+
+	if ((hp = gethostbyname(local_host)) == 0) {
+	    return (-1);
+	}
+	xmemcpy(&from_addr.sin_addr, hp->h_addr, hp->h_length);
+	from_addr.sin_port = 0;
+    }
+    return bind(sock, (struct sockaddr *) &from_addr, sizeof(struct sockaddr_in));
+}
+
+static int
 client_comm_connect(int sock, char *dest_host, u_short dest_port, struct timeval *tvp)
 {
     static const struct hostent *hp = NULL;
@@ -380,7 +411,7 @@
 }
 
 static void
-set_our_signal()
+set_our_signal(void)
 {
 #if HAVE_SIGACTION
     struct sigaction sa;
Index: squid/src/client_db.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_db.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/client_db.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/client_db.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_db.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: client_db.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 0     Client Database
  * AUTHOR: Duane Wessels
@@ -91,6 +91,30 @@
     }
 }
 
+/*
+ * clientdbEstablished()
+ * This function tracks the number of currently established connections
+ * for a client IP address.  When a connection is accepted, call this
+ * with delta = 1.  When the connection is closed, call with delta =
+ * -1.  To get the current value, simply call with delta = 0.
+ */
+int
+clientdbEstablished(struct in_addr addr, int delta)
+{
+    char *key;
+    ClientInfo *c;
+    if (!Config.onoff.client_db)
+	return 0;
+    key = inet_ntoa(addr);
+    c = (ClientInfo *) hash_lookup(client_table, key);
+    if (c == NULL)
+	c = clientdbAdd(addr);
+    if (c == NULL)
+	debug_trap("clientdbUpdate: Failed to add entry");
+    c->n_established += delta;
+    return c->n_established;
+}
+
 #define CUTOFF_SECONDS 3600
 int
 clientdbCutoffDenied(struct in_addr addr)
@@ -147,6 +171,8 @@
     while ((c = (ClientInfo *) hash_next(client_table))) {
 	storeAppendPrintf(sentry, "Address: %s\n", c->key);
 	storeAppendPrintf(sentry, "Name: %s\n", fqdnFromAddr(c->addr));
+	storeAppendPrintf(sentry, "Currently established connections: %d\n",
+	    c->n_established);
 	storeAppendPrintf(sentry, "    ICP Requests %d\n",
 	    c->Icp.n_requests);
 	for (l = LOG_TAG_NONE; l < LOG_TYPE_MAX; l++) {
@@ -230,18 +256,14 @@
 variable_list *
 snmp_meshCtblFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
+    variable_list *Answer = NULL;
     static char key[15];
     ClientInfo *c = NULL;
     int aggr = 0;
     log_type l;
-
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-
     debug(49, 6) ("snmp_meshCtblFn: Current : \n");
     snmpDebugOid(6, Var->name, Var->name_length);
-
     snprintf(key, sizeof(key), "%d.%d.%d.%d", Var->name[LEN_SQ_NET + 3], Var->name[LEN_SQ_NET + 4],
 	Var->name[LEN_SQ_NET + 5], Var->name[LEN_SQ_NET + 6]);
     debug(49, 5) ("snmp_meshCtblFn: [%s] requested!\n", key);
@@ -254,22 +276,19 @@
     }
     switch (Var->name[LEN_SQ_NET + 2]) {
     case MESH_CTBL_ADDR:
-	Answer->type = SMI_IPADDRESS;
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	*(Answer->val.integer) = (snint) c->addr.s_addr;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) c->addr.s_addr,
+	    SMI_IPADDRESS);
 	break;
     case MESH_CTBL_HTBYTES:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) c->Http.kbytes_out.kb;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) c->Http.kbytes_out.kb,
+	    SMI_COUNTER32);
 	break;
     case MESH_CTBL_HTREQ:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) c->Http.n_requests;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) c->Http.n_requests,
+	    SMI_COUNTER32);
 	break;
     case MESH_CTBL_HTHITS:
 	aggr = 0;
@@ -277,47 +296,40 @@
 	    if (isTcpHit(l))
 		aggr += c->Http.result_hist[l];
 	}
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) aggr;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) aggr,
+	    SMI_COUNTER32);
 	break;
     case MESH_CTBL_HTHITBYTES:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) c->Http.hit_kbytes_out.kb;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) c->Http.hit_kbytes_out.kb,
+	    SMI_COUNTER32);
 	break;
     case MESH_CTBL_ICPBYTES:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) c->Icp.kbytes_out.kb;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) c->Icp.kbytes_out.kb,
+	    SMI_COUNTER32);
 	break;
     case MESH_CTBL_ICPREQ:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) c->Icp.n_requests;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) c->Icp.n_requests,
+	    SMI_COUNTER32);
 	break;
     case MESH_CTBL_ICPHITS:
 	aggr = c->Icp.result_hist[LOG_UDP_HIT];
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) aggr;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) aggr,
+	    SMI_COUNTER32);
 	break;
     case MESH_CTBL_ICPHITBYTES:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = (snint) c->Icp.hit_kbytes_out.kb;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) c->Icp.hit_kbytes_out.kb,
+	    SMI_COUNTER32);
 	break;
     default:
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
 	debug(49, 5) ("snmp_meshCtblFn: illegal column.\n");
-	return (NULL);
+	break;
     }
     return Answer;
 }
